<<Combinatorica`;
<<MultivariateStatistics`;
<<ErrorBarPlots`;

<<DDUtils.m
<<FunctionMaker.m
<<DependencyDiagrams.m

Needs["Parallel`Debug`"];
Needs["Parallel`"];

StartNLocalKernels[n_] :=
    Map[LaunchSlave["localhost"]&,Range[n]];

StartNLocalKernels[8];

RemoteNeeds["Combinatorica`"];
RemoteNeeds["MultivariateStatistics`"];
RemoteNeeds["ErrorBarPlots`"];
RemoteNeeds["DDUtils`"];
RemoteNeeds["FunctionMaker`"];
RemoteNeeds["DependencyDiagrams`"];

Off[Part::"pspec"];

SetDirectory["/Users/johnsong/dependencydiagrams/dddevelopment/examples/graph_dynamics/"];

DepDiag = Graph[{{{2,1},EdgeLabel->FactorEdge,EdgeDirection->True},{{2,3},EdgeLabel->FactorEdge,EdgeDirection->True},{{4,1},EdgeLabel->IndexL,EdgeDirection->True},{{5,2},EdgeLabel->Gate,EdgeDirection->True},{{6,3},EdgeLabel->IndexL,EdgeDirection->True},{{4,5},EdgeLabel->IndexL,EdgeDirection->True},{{6,5},EdgeLabel->IndexL,EdgeDirection->True},{{4,7},EdgeLabel->ArgIndex,EdgeDirection->True},{{7,5},EdgeLabel->FactorEdge,EdgeDirection->True},{{6,7},EdgeLabel->ArgIndex,EdgeDirection->True}},{{{0.6,0.7},VertexLabel->VariableN[x]},{{-0.2,0.9},VertexLabel->FunctionN[f]},{{-0.9,0.4},VertexLabel->VariableN[x]},{{-0.9,-0.4},VertexLabel->IndexN[i]},{{-0.2,-0.9},VertexLabel->VariableN[G]},{{0.6,-0.7},VertexLabel->IndexN[j]},{{1.,0},VertexLabel->FunctionN[phi]}}]

CMP[q_] :=
    (lll^q)/((q!)^vvv)*(1/zzz);
ApprxCMPExp[lam_,nu_] :=
    (lam^(1/nu))-((nu-1)/(2nu));

f[xi_,xj_] :=
    E^(-TEMP*(DD2Norm[xi-xj,2]-d)^2);
phi[Gr_] :=
    CMP[DDTotal[Gr, {1,2}]];

NUMDATA = 10;
IGNOREBEFORE = 500;
ITERZ = 6000;
VARIABLES = {{x,Continuous,{{0,10},{0,10}}},{G,Discrete,{0,1}}};
(* Two indices, both over the number of data points we care about. *)
INDICES = {{i,1,NUMDATA}, {j,1,NUMDATA}};


(*code = GenerateMCMCCode[DepDiag, VARIABLES, INDICES, ITERZ];
code >> "generated_graphdyn_mcmcalg.m";*)
code =<< "generated_graphdyn_mcmcalg.m";
code = ReplaceAll[code, DDList->DDCollect];

xatt[t_] :=
    DDCollect[x,{{1,NUMDATA},t}];
gatt[t_] :=
    DDCollect[G,{{1,NUMDATA},{1,NUMDATA},t}];

l = {5,10,15,20,25,30,35,40,45,50};
v = {1,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2};
LVPairs = Tuples[{l,v}]
(*TEMPS = {.5,1,2};*)
TEMPS = {1};
RUNSPERSETUP = 3;
d = 1;

run[{l_, v_}, temp_] :=
	Module[{priorOnConnections, itG, adc, sizes, dists, counttotals, it, distL, itx},		
		d = 1;		
		lll = l;
		vvv = v;		
		TEMP = temp;
		code[[2]][];		
		priorOnConnections = ApprxCMPExp[lll,vvv];
		sizes = {};
		dists = {};		
		counttotals = Table[0, {(NUMDATA^2)+1}];
		For[it = IGNOREBEFORE+1, it<=ITERZ, it+=1,
			itG = gatt[it];
			adc = Total[itG, {1,2}];
			AppendTo[sizes,adc];
			counttotals[[adc+1]]++;
			distL = {};
			itx = xatt[it];
			Map[If[itG[[#[[1]], #[[2]]]] == 1, AppendTo[distL, Norm[itx[[#[[1]]]] - itx[[#[[2]]]]]]] &, Tuples[Range[NUMDATA], 2]];
			If[Length[distL] > 0,
 				AppendTo[dists, Mean[distL]];
  			];
		];
		{sizes, dists, counttotals, priorOnConnections, l, v, temp}			
	];

ExportEnvironment[ApprxCMPExp, NUMDATA, IGNOREBEFORE, ITERZ, gatt, xatt, code, f, phi, CMP, run,d]

RemoteEvaluate[code[[1]][]];
	
notdone = {};
assoc = {};
For[lvcounter = 1,lvcounter<=Length[LVPairs],lvcounter++,
	For[tempcounter = 1,tempcounter<=Length[TEMPS],tempcounter++,
		allsizes[LVPairs[[lvcounter,1]],LVPairs[[lvcounter,2]],TEMPS[[tempcounter]]] = {};
		alldists[LVPairs[[lvcounter,1]],LVPairs[[lvcounter,2]],TEMPS[[tempcounter]]] = {};
		alltotals[LVPairs[[lvcounter,1]],LVPairs[[lvcounter,2]],TEMPS[[tempcounter]]] = {};
		exps[LVPairs[[lvcounter,1]],LVPairs[[lvcounter,2]],TEMPS[[tempcounter]]] = 0;						
		For[eachcounter = 1,eachcounter<=RUNSPERSETUP,eachcounter++,
			pid = ReleaseHold[ReplaceAll[Hold[Queue[run[a, b]]], {a->LVPairs[[lvcounter]], b->TEMPS[[tempcounter]]}]];
			AppendTo[notdone, pid];
			AppendTo[assoc, {pid, LVPairs[[lvcounter]], TEMPS[[tempcounter]], eachcounter}];			
		];
	];
];


While[notdone!={},
	{{sizes, dists, counttotals, pOC, l, v, temp}, id, notdone} = WaitOne[notdone];
	allsizes[l,v,temp] = Append[allsizes[l,v,temp], sizes];
	alldists[l,v,temp] = Append[alldists[l,v,temp], dists];
	alltotals[l,v,temp] = Append[alltotals[l,v,temp], counttotals];
	exps[l,v,temp] = pOC;		
	Print[Length[notdone]];
]


Print["\ntemp", "\t" ,"lam","\t","nu","\t","E", "\t", "m[n]", "\t", "m[d]", "\t", "v[n]", "\t", "v[d]"];
first = True;
For[lvcounter = 1,lvcounter<=Length[LVPairs],lvcounter++,
	For[tempcounter = 1,tempcounter<=Length[TEMPS],tempcounter++,
		sl = {};
		dl = {};
		For[eachcounter = 1,eachcounter<=RUNSPERSETUP,eachcounter++,
			sl = Join[sl, allsizes[LVPairs[[lvcounter,1]],LVPairs[[lvcounter,2]],TEMPS[[tempcounter]]][[eachcounter]]];
			dl = Join[dl, alldists[LVPairs[[lvcounter,1]],LVPairs[[lvcounter,2]],TEMPS[[tempcounter]]][[eachcounter]]];
		];
		If[first, Print["\n"]; first=False];
		Print[TEMPS[[tempcounter]], "\t", LVPairs[[lvcounter,1]], "\t", LVPairs[[lvcounter,2]], "\t", N[exps[LVPairs[[lvcounter,1]],LVPairs[[lvcounter,2]],TEMPS[[tempcounter]]]], "\t", N[Mean[sl]],"\t", N[Mean[dl]], "\t", N[Variance[sl]],"\t", N[Variance[dl]]];
	];
];

{exps,
 allsizes,
 alldists,
 alltotals} >>"data_04.dat"
