(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    130996,       3894]
NotebookOptionsPosition[    113993,       3456]
NotebookOutlinePosition[    114348,       3472]
CellTagsIndexPosition[    114305,       3469]
WindowFrame->Generic
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
  "SetDirectory", "[", 
   "\"\</shared/code/ecl_workspace/dddevelopment/examples/alarm\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Import", "[", 
   RowBox[{"\"\<alarm.bif\>\"", ",", " ", "\"\<String\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"exact", " ", "=", " ", 
   RowBox[{"Import", "[", 
    RowBox[{
    "\"\</shared/code/ecl_workspace/dddevelopment/examples/alarm/alarm-\
marginals.txt\>\"", ",", "\"\<Table\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"<<", "Combinatorica`"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"<<", "DependencyDiagrams`"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "<<", "\"\</shared/code/ecl_workspace/dddevelopment/BIFParser.m\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"diagram", ",", " ", "vars", ",", " ", "funcs"}], "}"}], " ", "=",
    " ", 
   RowBox[{"BIF2DD", "[", "\"\<alarm.bif\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{"ToExpression", ",", " ", "funcs"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.425747869822209*^9, 3.42574787114738*^9}, {
  3.425748807231475*^9, 3.425748808096999*^9}, {3.425952469083977*^9, 
  3.425952469552477*^9}, {3.426528907403268*^9, 3.42652890763572*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"code", " ", "=", " ", 
   RowBox[{"Quiet", "[", 
    RowBox[{"GenerateMCMCCode", "[", 
     RowBox[{"diagram", ",", "vars", ",", 
      RowBox[{"{", "}"}], ",", "TOTAL", ",", 
      RowBox[{"{", "}"}], ",", 
      RowBox[{"{", "}"}], ",", "True"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<code generated; moving on.\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"code", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "[", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", " ", ":=", " ", "\[IndentingNewLine]", 
   RowBox[{"Map", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", "var", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", "all", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"all", " ", "=", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"var", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{"ignore", "+", "1"}], ";;", "total"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Function", "[", 
             RowBox[{
              RowBox[{"{", "which", "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Length", "[", 
               RowBox[{"Cases", "[", 
                RowBox[{"all", ",", "which"}], "]"}], "]"}]}], 
             "\[IndentingNewLine]", "]"}], ",", 
            RowBox[{"var", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}]}], "]"}], ",", " ", "vars"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"est", " ", ":=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", "l", "}"}], ",", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", "t", "}"}], ",", 
         RowBox[{
          RowBox[{"t", "=", 
           RowBox[{"Total", "[", "l", "]"}]}], ";", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"N", "[", 
              RowBox[{"#", "/", "t"}], "]"}], "&"}], ",", "l"}], "]"}]}]}], 
        "]"}]}], "]"}], ",", "totalNums"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"diffs", "  ", ":=", " ", 
   RowBox[{"Abs", "[", 
    RowBox[{"est", "-", "exact"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"list", " ", ":=", " ", 
   RowBox[{"Flatten", "[", "diffs", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"kld", "[", 
    RowBox[{"p_", ",", "q_"}], "]"}], ":=", 
   RowBox[{"Total", "[", 
    RowBox[{"MapThread", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"#2", "\[Equal]", "0"}], ",", "Infinity", ",", 
         RowBox[{"#1", "*", 
          RowBox[{"(", 
           RowBox[{"Log", "[", 
            RowBox[{"#1", "/", "#2"}], "]"}], ")"}]}]}], "]"}], "&"}], ",", 
      RowBox[{"{", 
       RowBox[{"p", ",", "q"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ignore", " ", "=", " ", "5000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"total", " ", "=", "  ", 
   RowBox[{"ignore", "+", "50000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"code", "[", 
       RowBox[{"[", "2", "]"}], "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{"TOTAL", "\[Rule]", "total"}], "}"}]}], ")"}], "[", "True", 
    "]"}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"totalNums", " ", "=", " ", "nums"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"continue", " ", "=", " ", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"it", " ", "=", " ", "total"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"While", "[", 
  RowBox[{"continue", ",", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Max", "[", "list", "]"}], "<", ".0001"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"continue", "=", "False"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "else", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"it", " ", "\[GreaterEqual]", " ", "205000"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{
          "\"\<writing est at <\>\"", ",", " ", "it", ",", " ", "\"\<>\>\""}],
           "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"est", " ", ">>", "\"\<est.txt\>\""}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"Max", "[", "list", "]"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"div1", " ", "=", " ", 
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"kld", "[", 
           RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{"exact", ",", "est"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"it", ",", " ", "\"\< m[kld] = \>\"", ",", 
        RowBox[{"Mean", "[", "div1", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{
        RowBox[{"HISTORY", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"HISTORY", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"CVP", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"CVP", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"PCWP", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"PCWP", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"HYPOVOLEMIA", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"HYPOVOLEMIA", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"LVEDVOLUME", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"LVEDVOLUME", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"LVFAILURE", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"LVFAILURE", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"STROKEVOLUME", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"STROKEVOLUME", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"ERRLOWOUTPUT", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"ERRLOWOUTPUT", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"HRBP", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"HRBP", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"HREKG", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"HREKG", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"ERRCAUTER", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"ERRCAUTER", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"HRSAT", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"HRSAT", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"INSUFFANESTH", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"INSUFFANESTH", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"ANAPHYLAXIS", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"ANAPHYLAXIS", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"TPR", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"TPR", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"EXPCO2", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"EXPCO2", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"KINKEDTUBE", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"KINKEDTUBE", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"MINVOL", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"MINVOL", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"FIO2", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"FIO2", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"PVSAT", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"PVSAT", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"SAO2", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"SAO2", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"PAP", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"PAP", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"PULMEMBOLUS", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"PULMEMBOLUS", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"SHUNT", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"SHUNT", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"INTUBATION", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"INTUBATION", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"PRESS", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"PRESS", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"DISCONNECT", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"DISCONNECT", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"MINVOLSET", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"MINVOLSET", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"VENTMACH", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"VENTMACH", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"VENTTUBE", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"VENTTUBE", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"VENTLUNG", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"VENTLUNG", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"VENTALV", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"VENTALV", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"ARTCO2", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"ARTCO2", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"CATECHOL", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"CATECHOL", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"HR", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"HR", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"CO", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"CO", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[";",
       ShowStringCharacters->True,
       NumberMarks->True], 
      StyleBox[
       RowBox[{
        RowBox[{"BP", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"BP", "[", 
         RowBox[{"[", "total", "]"}], "]"}]}],
       ShowStringCharacters->True,
       NumberMarks->True], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      
      RowBox[{"ignore", " ", "=", " ", "1"}], ";", "\[IndentingNewLine]", 
      RowBox[{"total", " ", "=", " ", "10000"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"code", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "/.", 
         RowBox[{"{", 
          RowBox[{"TOTAL", "\[Rule]", "total"}], "}"}]}], ")"}], "[", "False",
        "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"totalNums", " ", "+=", " ", "nums"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"it", "+=", "total"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]", "]"}]}], "Input",
 CellChangeTimes->{{3.390756898276002*^9, 3.390756929324278*^9}, {
   3.390758715910553*^9, 3.390758719543538*^9}, {3.390758849703091*^9, 
   3.390758853836843*^9}, {3.390760019132001*^9, 3.39076007396379*^9}, {
   3.390774071442923*^9, 3.390774077398063*^9}, 3.390774729188957*^9, {
   3.390776945543816*^9, 3.39077698300086*^9}, {3.390777379724957*^9, 
   3.390777460573208*^9}, {3.390777625201724*^9, 3.390777626983496*^9}, {
   3.390777828496991*^9, 3.390777832131158*^9}, {3.390778094980983*^9, 
   3.390778097259281*^9}, 3.390779011901252*^9, {3.390779361882083*^9, 
   3.390779370894116*^9}, {3.390780092079237*^9, 3.390780119274077*^9}, {
   3.390780338320319*^9, 3.390780381477777*^9}, {3.390780498589804*^9, 
   3.390780500525117*^9}, {3.390789996938996*^9, 3.390790028419953*^9}, {
   3.390790084169174*^9, 3.390790101964897*^9}, {3.390790249002716*^9, 
   3.390790393048582*^9}, {3.390790498471208*^9, 3.390790549354419*^9}, {
   3.390790818447315*^9, 3.390790844243874*^9}, {3.390825497359595*^9, 
   3.390825499878113*^9}, {3.390833880757088*^9, 3.390834006113557*^9}, {
   3.39083405749235*^9, 3.390834210247284*^9}, 3.390835263510385*^9, {
   3.390835349501664*^9, 3.390835416131936*^9}, {3.390869647770025*^9, 
   3.390869662360479*^9}, {3.39086971204938*^9, 3.390869732007803*^9}, {
   3.390869823524161*^9, 3.390869825652772*^9}, {3.390869859604618*^9, 
   3.390869865334149*^9}, {3.390869913366871*^9, 3.390869980629034*^9}, {
   3.390870029078741*^9, 3.390870049649491*^9}, {3.390870089643779*^9, 
   3.390870167633844*^9}, {3.390870576797375*^9, 3.390870586162922*^9}, {
   3.390871509371713*^9, 3.390871511143302*^9}, {3.39087158624564*^9, 
   3.390871588220273*^9}, {3.425404993253425*^9, 3.425404999231145*^9}, {
   3.425840595321591*^9, 3.425840681715333*^9}, {3.42584076836456*^9, 
   3.425840800308189*^9}, {3.425841735956584*^9, 3.425841741707175*^9}, {
   3.425844310692773*^9, 3.425844311316718*^9}, {3.425920229681177*^9, 
   3.42592031102484*^9}, {3.425920538573812*^9, 3.425920542283898*^9}, {
   3.425920580115951*^9, 3.425920630898314*^9}, 3.425925865787564*^9, {
   3.425926520496502*^9, 3.425926523625252*^9}, {3.425926639630189*^9, 
   3.425926751275012*^9}, {3.425951814750605*^9, 3.425951841904895*^9}, {
   3.425952412588652*^9, 3.425952420075243*^9}, {3.425954503392657*^9, 
   3.425954560093398*^9}, {3.425990208782386*^9, 3.425990234208241*^9}, {
   3.425991805515042*^9, 3.425991813578369*^9}, {3.425991874920109*^9, 
   3.425991875710108*^9}, {3.426272619629848*^9, 3.426272649452822*^9}, {
   3.42627273426912*^9, 3.426272774907936*^9}, {3.426273247281074*^9, 
   3.426273252618992*^9}, {3.426273472436627*^9, 3.426273473389568*^9}, {
   3.426274085226292*^9, 3.426274119196246*^9}, {3.426276031250915*^9, 
   3.426276037067591*^9}, {3.426276120592968*^9, 3.426276140824036*^9}, 
   3.42635837630182*^9, {3.426426898546892*^9, 3.42642692207768*^9}, {
   3.426427085383159*^9, 3.426427091501146*^9}, {3.426427175630036*^9, 
   3.426427190347254*^9}, {3.426429910911027*^9, 3.426429911986637*^9}, {
   3.426527658779916*^9, 3.426527699031672*^9}, {3.426528842928635*^9, 
   3.426528852785522*^9}, {3.426528912707281*^9, 3.42652891515699*^9}, 
   3.426553748668907*^9, {3.426561207013189*^9, 3.426561207554654*^9}, {
   3.426600765944714*^9, 3.426600768441328*^9}, {3.42662584545574*^9, 
   3.426625845619081*^9}, {3.426626930190297*^9, 3.426626948242123*^9}, 
   3.426858880560515*^9, {3.42685891570111*^9, 3.426858941686164*^9}, {
   3.426862771831715*^9, 3.426862784099947*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"code generated; moving on.\"\>"], "Print",
 CellChangeTimes->{3.426863786778*^9}],

Cell[BoxData["0.15990073082758816`"], "Print",
 CellChangeTimes->{3.426873242151992*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "55000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.01873312201143395`"}],
  SequenceForm[55000, " m[kld] = ", 0.01873312201143395],
  Editable->False]], "Print",
 CellChangeTimes->{3.426873242334731*^9}],

Cell[BoxData["0.1505422838534719`"], "Print",
 CellChangeTimes->{3.42687496574468*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "65000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.014607018518580175`"}],
  SequenceForm[65000, " m[kld] = ", 0.014607018518580175`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426874965854367*^9}],

Cell[BoxData["0.07179828618631268`"], "Print",
 CellChangeTimes->{3.426877282647546*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "75000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.004113810466743612`"}],
  SequenceForm[75000, " m[kld] = ", 0.004113810466743612],
  Editable->False]], "Print",
 CellChangeTimes->{3.42687728270745*^9}],

Cell[BoxData["0.041345594313577066`"], "Print",
 CellChangeTimes->{3.42687920376971*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "85000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0016714572761205978`"}],
  SequenceForm[85000, " m[kld] = ", 0.0016714572761205978`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426879203837414*^9}],

Cell[BoxData["0.02803388065842688`"], "Print",
 CellChangeTimes->{3.426881822773729*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "95000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0013529044301093024`"}],
  SequenceForm[95000, " m[kld] = ", 0.0013529044301093024`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426881822841145*^9}],

Cell[BoxData["0.04087945274929006`"], "Print",
 CellChangeTimes->{3.426884046012562*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "105000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0014651885693571583`"}],
  SequenceForm[105000, " m[kld] = ", 0.0014651885693571583`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426884046082042*^9}],

Cell[BoxData["0.06903608607746259`"], "Print",
 CellChangeTimes->{3.426886670196941*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "115000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0033385359815829093`"}],
  SequenceForm[115000, " m[kld] = ", 0.0033385359815829093`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426886670262307*^9}],

Cell[BoxData["0.08714340805846588`"], "Print",
 CellChangeTimes->{3.42688929178456*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "125000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.004929257464352345`"}],
  SequenceForm[125000, " m[kld] = ", 0.004929257464352345],
  Editable->False]], "Print",
 CellChangeTimes->{3.426889291849917*^9}],

Cell[BoxData["0.06641672313922842`"], "Print",
 CellChangeTimes->{3.426891914196049*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "135000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.003011909905663959`"}],
  SequenceForm[135000, " m[kld] = ", 0.003011909905663959],
  Editable->False]], "Print",
 CellChangeTimes->{3.426891914267*^9}],

Cell[BoxData["0.06245223514079368`"], "Print",
 CellChangeTimes->{3.426894258502925*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "145000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0020365455003497996`"}],
  SequenceForm[145000, " m[kld] = ", 0.0020365455003497996`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426894258568825*^9}],

Cell[BoxData["0.07538322619257787`"], "Print",
 CellChangeTimes->{3.426896734686359*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "155000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.002570005636565227`"}],
  SequenceForm[155000, " m[kld] = ", 0.002570005636565227],
  Editable->False]], "Print",
 CellChangeTimes->{3.42689673475657*^9}],

Cell[BoxData["0.08199797365931305`"], "Print",
 CellChangeTimes->{3.426898953873148*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "165000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0039300582446775145`"}],
  SequenceForm[165000, " m[kld] = ", 0.0039300582446775145`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426898953939088*^9}],

Cell[BoxData["0.08301066851151206`"], "Print",
 CellChangeTimes->{3.426900983730951*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "175000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00491327528469468`"}],
  SequenceForm[175000, " m[kld] = ", 0.00491327528469468],
  Editable->False]], "Print",
 CellChangeTimes->{3.426900983776448*^9}],

Cell[BoxData["0.07278226333062943`"], "Print",
 CellChangeTimes->{3.426903202573781*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "185000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0035960044656648906`"}],
  SequenceForm[185000, " m[kld] = ", 0.0035960044656648906`],
  Editable->False]], "Print",
 CellChangeTimes->{3.42690320261915*^9}],

Cell[BoxData["0.07574718632554545`"], "Print",
 CellChangeTimes->{3.426905337922019*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "195000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.004111461010128604`"}],
  SequenceForm[195000, " m[kld] = ", 0.004111461010128604],
  Editable->False]], "Print",
 CellChangeTimes->{3.426905338011276*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "205000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 205000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426907978828251*^9}],

Cell[BoxData["0.07529039004125393`"], "Print",
 CellChangeTimes->{3.426907978905275*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "205000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.003990708073751575`"}],
  SequenceForm[205000, " m[kld] = ", 0.003990708073751575],
  Editable->False]], "Print",
 CellChangeTimes->{3.426907978960875*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "215000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 215000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426910631583586*^9}],

Cell[BoxData["0.07630101514189291`"], "Print",
 CellChangeTimes->{3.42691063164434*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "215000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0035100348749098806`"}],
  SequenceForm[215000, " m[kld] = ", 0.0035100348749098806`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426910631690424*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "225000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 225000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4269129065356*^9}],

Cell[BoxData["0.0735012981671781`"], "Print",
 CellChangeTimes->{3.42691290659617*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "225000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0031050305097832`"}],
  SequenceForm[225000, " m[kld] = ", 0.0031050305097832],
  Editable->False]], "Print",
 CellChangeTimes->{3.426912906642228*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "235000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 235000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4269155502149*^9}],

Cell[BoxData["0.07309302374040316`"], "Print",
 CellChangeTimes->{3.426915550277131*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "235000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00275404286155788`"}],
  SequenceForm[235000, " m[kld] = ", 0.00275404286155788],
  Editable->False]], "Print",
 CellChangeTimes->{3.426915550322601*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "245000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 245000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426917780263198*^9}],

Cell[BoxData["0.0811236035228643`"], "Print",
 CellChangeTimes->{3.426917780324688*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "245000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0032819099200124637`"}],
  SequenceForm[245000, " m[kld] = ", 0.0032819099200124637`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426917780367915*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "255000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 255000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426920425006798*^9}],

Cell[BoxData["0.07143838390341462`"], "Print",
 CellChangeTimes->{3.426920425067239*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "255000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0026459166643765424`"}],
  SequenceForm[255000, " m[kld] = ", 0.0026459166643765424`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426920425114171*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "265000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 265000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426922855118747*^9}],

Cell[BoxData["0.06662761517423954`"], "Print",
 CellChangeTimes->{3.426922855162035*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "265000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0022549868477848`"}],
  SequenceForm[265000, " m[kld] = ", 0.0022549868477848],
  Editable->False]], "Print",
 CellChangeTimes->{3.426922855185557*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "275000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 275000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426925316573215*^9}],

Cell[BoxData["0.06204591951331606`"], "Print",
 CellChangeTimes->{3.426925316634323*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "275000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0019793495151348046`"}],
  SequenceForm[275000, " m[kld] = ", 0.0019793495151348046`],
  Editable->False]], "Print",
 CellChangeTimes->{3.42692531667954*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "285000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 285000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426927685004552*^9}],

Cell[BoxData["0.05789867861160314`"], "Print",
 CellChangeTimes->{3.426927685037633*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "285000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0016946799360408724`"}],
  SequenceForm[285000, " m[kld] = ", 0.0016946799360408724`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426927685061282*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "295000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 295000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426930179735308*^9}],

Cell[BoxData["0.0639202625486106`"], "Print",
 CellChangeTimes->{3.426930179767882*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "295000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0023737201158973934`"}],
  SequenceForm[295000, " m[kld] = ", 0.0023737201158973934`],
  Editable->False]], "Print",
 CellChangeTimes->{3.42693017978294*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "305000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 305000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42693204156389*^9}],

Cell[BoxData["0.07232731315593299`"], "Print",
 CellChangeTimes->{3.426932041625056*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "305000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0032058377907597537`"}],
  SequenceForm[305000, " m[kld] = ", 0.0032058377907597537`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426932041655983*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "315000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 315000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426934201215685*^9}],

Cell[BoxData["0.06671665220204415`"], "Print",
 CellChangeTimes->{3.426934201291983*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "315000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0025861692002817943`"}],
  SequenceForm[315000, " m[kld] = ", 0.0025861692002817943`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426934201337011*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "325000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 325000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426936853543095*^9}],

Cell[BoxData["0.064221852620858`"], "Print",
 CellChangeTimes->{3.426936853604733*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "325000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0021408090751257737`"}],
  SequenceForm[325000, " m[kld] = ", 0.0021408090751257737`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426936853648148*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "335000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 335000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426939351270995*^9}],

Cell[BoxData["0.060387215120165316`"], "Print",
 CellChangeTimes->{3.426939351304685*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "335000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0017868735636635531`"}],
  SequenceForm[335000, " m[kld] = ", 0.0017868735636635531`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426939351328246*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "345000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 345000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426941720711827*^9}],

Cell[BoxData["0.057022279684468824`"], "Print",
 CellChangeTimes->{3.42694172077493*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "345000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.001470380694548837`"}],
  SequenceForm[345000, " m[kld] = ", 0.001470380694548837],
  Editable->False]], "Print",
 CellChangeTimes->{3.426941720819063*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "355000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 355000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426944365533002*^9}],

Cell[BoxData["0.051743728735565764`"], "Print",
 CellChangeTimes->{3.426944365593522*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "355000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0011642660678986838`"}],
  SequenceForm[355000, " m[kld] = ", 0.0011642660678986838`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426944365640692*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "365000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 365000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42694700942783*^9}],

Cell[BoxData["0.04949755130181577`"], "Print",
 CellChangeTimes->{3.426947009488918*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "365000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0009817104870693618`"}],
  SequenceForm[365000, " m[kld] = ", 0.0009817104870693618],
  Editable->False]], "Print",
 CellChangeTimes->{3.42694700953246*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "375000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 375000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426949645746828*^9}],

Cell[BoxData["0.050792001858378844`"], "Print",
 CellChangeTimes->{3.426949645809525*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "375000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0010335676835013735`"}],
  SequenceForm[375000, " m[kld] = ", 0.0010335676835013735`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426949645853464*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "385000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 385000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426952279175186*^9}],

Cell[BoxData["0.05506069380372003`"], "Print",
 CellChangeTimes->{3.42695227923689*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "385000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.001274656639294733`"}],
  SequenceForm[385000, " m[kld] = ", 0.001274656639294733],
  Editable->False]], "Print",
 CellChangeTimes->{3.426952279281946*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "395000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 395000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426954920385354*^9}],

Cell[BoxData["0.05307149326222149`"], "Print",
 CellChangeTimes->{3.426954920445974*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "395000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0011667745537694404`"}],
  SequenceForm[395000, " m[kld] = ", 0.0011667745537694404`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426954920490335*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "405000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 405000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426957564589126*^9}],

Cell[BoxData["0.04809398132454801`"], "Print",
 CellChangeTimes->{3.426957564651271*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "405000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0009640580420940514`"}],
  SequenceForm[405000, " m[kld] = ", 0.0009640580420940514],
  Editable->False]], "Print",
 CellChangeTimes->{3.426957564718539*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "415000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 415000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426960216622198*^9}],

Cell[BoxData["0.05062332433933281`"], "Print",
 CellChangeTimes->{3.426960216685821*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "415000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0011224227718199449`"}],
  SequenceForm[415000, " m[kld] = ", 0.0011224227718199449`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426960216728137*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "425000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 425000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426962853041552*^9}],

Cell[BoxData["0.049920044952597276`"], "Print",
 CellChangeTimes->{3.426962853101838*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "425000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0013761950614347585`"}],
  SequenceForm[425000, " m[kld] = ", 0.0013761950614347585`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426962853147276*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "435000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 435000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4269654891373*^9}],

Cell[BoxData["0.04572823444259022`"], "Print",
 CellChangeTimes->{3.426965489198515*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "435000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0011197650085658232`"}],
  SequenceForm[435000, " m[kld] = ", 0.0011197650085658232`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426965489245182*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "445000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 445000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426968118919121*^9}],

Cell[BoxData["0.04453857145606621`"], "Print",
 CellChangeTimes->{3.426968118982818*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "445000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0009655620595908716`"}],
  SequenceForm[445000, " m[kld] = ", 0.0009655620595908716],
  Editable->False]], "Print",
 CellChangeTimes->{3.42696811902649*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "455000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 455000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426970751169013*^9}],

Cell[BoxData["0.04221723205475991`"], "Print",
 CellChangeTimes->{3.426970751230318*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "455000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0008498982023998051`"}],
  SequenceForm[455000, " m[kld] = ", 0.0008498982023998051],
  Editable->False]], "Print",
 CellChangeTimes->{3.426970751274057*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "465000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 465000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42697338944795*^9}],

Cell[BoxData["0.03743789562621258`"], "Print",
 CellChangeTimes->{3.426973389511641*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "465000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0008683472027319164`"}],
  SequenceForm[465000, " m[kld] = ", 0.0008683472027319164],
  Editable->False]], "Print",
 CellChangeTimes->{3.426973389558853*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "475000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 475000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426976029282263*^9}],

Cell[BoxData["0.03480040414955066`"], "Print",
 CellChangeTimes->{3.426976029346097*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "475000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.000804674636048729`"}],
  SequenceForm[475000, " m[kld] = ", 0.000804674636048729],
  Editable->False]], "Print",
 CellChangeTimes->{3.426976029389191*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "485000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 485000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426978665036858*^9}],

Cell[BoxData["0.03125396573503858`"], "Print",
 CellChangeTimes->{3.426978665101158*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "485000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0006440241060815278`"}],
  SequenceForm[485000, " m[kld] = ", 0.0006440241060815278],
  Editable->False]], "Print",
 CellChangeTimes->{3.42697866514581*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "495000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 495000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426981309110593*^9}],

Cell[BoxData["0.03053415190602682`"], "Print",
 CellChangeTimes->{3.426981309172051*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "495000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0005495599993067255`"}],
  SequenceForm[495000, " m[kld] = ", 0.0005495599993067255],
  Editable->False]], "Print",
 CellChangeTimes->{3.426981309221895*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "505000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 505000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426983947318645*^9}],

Cell[BoxData["0.03509560306476911`"], "Print",
 CellChangeTimes->{3.426983947380696*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "505000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.000623220056856907`"}],
  SequenceForm[505000, " m[kld] = ", 0.000623220056856907],
  Editable->False]], "Print",
 CellChangeTimes->{3.42698394742838*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "515000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 515000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42698658161443*^9}],

Cell[BoxData["0.03249323179977803`"], "Print",
 CellChangeTimes->{3.426986581676484*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "515000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.000501363397147936`"}],
  SequenceForm[515000, " m[kld] = ", 0.000501363397147936],
  Editable->False]], "Print",
 CellChangeTimes->{3.426986581723149*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "525000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 525000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426989215859216*^9}],

Cell[BoxData["0.028400422400104208`"], "Print",
 CellChangeTimes->{3.426989215919935*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "525000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00037667402161883136`"}],
  SequenceForm[525000, " m[kld] = ", 0.00037667402161883136`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426989215960395*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "535000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 535000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426991862918277*^9}],

Cell[BoxData["0.028145409635549568`"], "Print",
 CellChangeTimes->{3.42699186298154*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "535000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0003416699556795574`"}],
  SequenceForm[535000, " m[kld] = ", 0.0003416699556795574],
  Editable->False]], "Print",
 CellChangeTimes->{3.426991863025145*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "545000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 545000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426994507488859*^9}],

Cell[BoxData["0.027690563451417183`"], "Print",
 CellChangeTimes->{3.426994507554937*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "545000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0003384639712077783`"}],
  SequenceForm[545000, " m[kld] = ", 0.0003384639712077783],
  Editable->False]], "Print",
 CellChangeTimes->{3.426994507604962*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "555000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 555000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426997158654335*^9}],

Cell[BoxData["0.026364903582386634`"], "Print",
 CellChangeTimes->{3.426997158721203*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "555000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0003072600693654375`"}],
  SequenceForm[555000, " m[kld] = ", 0.0003072600693654375],
  Editable->False]], "Print",
 CellChangeTimes->{3.426997158765124*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "565000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 565000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.426999805273718*^9}],

Cell[BoxData["0.025106232932125883`"], "Print",
 CellChangeTimes->{3.426999805338173*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "565000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00027483700573431683`"}],
  SequenceForm[565000, " m[kld] = ", 0.00027483700573431683`],
  Editable->False]], "Print",
 CellChangeTimes->{3.426999805381578*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "575000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 575000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427002451208275*^9}],

Cell[BoxData["0.02352151656482404`"], "Print",
 CellChangeTimes->{3.427002451271768*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "575000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0002712894113176306`"}],
  SequenceForm[575000, " m[kld] = ", 0.0002712894113176306],
  Editable->False]], "Print",
 CellChangeTimes->{3.427002451316293*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "585000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 585000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427005084705952*^9}],

Cell[BoxData["0.022377687309470873`"], "Print",
 CellChangeTimes->{3.427005084767216*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "585000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00024720567480522506`"}],
  SequenceForm[585000, " m[kld] = ", 0.00024720567480522506`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427005084813373*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "595000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 595000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427007725848583*^9}],

Cell[BoxData["0.021701484408815475`"], "Print",
 CellChangeTimes->{3.427007725910269*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "595000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00026724760802085846`"}],
  SequenceForm[595000, " m[kld] = ", 0.00026724760802085846`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427007725954025*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "605000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 605000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427010366392314*^9}],

Cell[BoxData["0.02735339942831505`"], "Print",
 CellChangeTimes->{3.427010366453108*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "605000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0003390200327433022`"}],
  SequenceForm[605000, " m[kld] = ", 0.0003390200327433022],
  Editable->False]], "Print",
 CellChangeTimes->{3.427010366500002*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "615000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 615000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427013015997715*^9}],

Cell[BoxData["0.030647676703103643`"], "Print",
 CellChangeTimes->{3.427013016060941*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "615000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0004861855726014039`"}],
  SequenceForm[615000, " m[kld] = ", 0.0004861855726014039],
  Editable->False]], "Print",
 CellChangeTimes->{3.427013016102784*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "625000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 625000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427015359098802*^9}],

Cell[BoxData["0.030161156457892413`"], "Print",
 CellChangeTimes->{3.427015359132514*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "625000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0004956332105241711`"}],
  SequenceForm[625000, " m[kld] = ", 0.0004956332105241711],
  Editable->False]], "Print",
 CellChangeTimes->{3.427015359157101*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "635000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 635000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42701788622622*^9}],

Cell[BoxData["0.028791585760201133`"], "Print",
 CellChangeTimes->{3.427017886289146*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "635000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0004316801734560918`"}],
  SequenceForm[635000, " m[kld] = ", 0.0004316801734560918],
  Editable->False]], "Print",
 CellChangeTimes->{3.427017886337753*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "645000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 645000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427020529638341*^9}],

Cell[BoxData["0.028786810684000574`"], "Print",
 CellChangeTimes->{3.427020529700065*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "645000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0004570332292459772`"}],
  SequenceForm[645000, " m[kld] = ", 0.0004570332292459772],
  Editable->False]], "Print",
 CellChangeTimes->{3.427020529744556*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "655000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 655000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427022763890006*^9}],

Cell[BoxData["0.029017588877292333`"], "Print",
 CellChangeTimes->{3.427022763953193*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "655000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.000573472761336663`"}],
  SequenceForm[655000, " m[kld] = ", 0.000573472761336663],
  Editable->False]], "Print",
 CellChangeTimes->{3.427022763998118*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "665000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 665000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427025408899617*^9}],

Cell[BoxData["0.026548700734287167`"], "Print",
 CellChangeTimes->{3.42702540896409*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "665000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00046210945797544884`"}],
  SequenceForm[665000, " m[kld] = ", 0.00046210945797544884`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427025409008212*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "675000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 675000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42702803959646*^9}],

Cell[BoxData["0.025814857961277138`"], "Print",
 CellChangeTimes->{3.427028039657899*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "675000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00043182924448419266`"}],
  SequenceForm[675000, " m[kld] = ", 0.00043182924448419266`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427028039705821*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "685000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 685000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427030276152942*^9}],

Cell[BoxData["0.023006816237150618`"], "Print",
 CellChangeTimes->{3.427030276213187*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "685000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00035396961720816927`"}],
  SequenceForm[685000, " m[kld] = ", 0.00035396961720816927`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427030276257781*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "695000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 695000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427032916365315*^9}],

Cell[BoxData["0.024179078799797193`"], "Print",
 CellChangeTimes->{3.427032916427447*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "695000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0003423737343724845`"}],
  SequenceForm[695000, " m[kld] = ", 0.0003423737343724845],
  Editable->False]], "Print",
 CellChangeTimes->{3.427032916471286*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "705000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 705000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427035566372177*^9}],

Cell[BoxData["0.028581008536213037`"], "Print",
 CellChangeTimes->{3.427035566433615*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "705000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0005141449271819395`"}],
  SequenceForm[705000, " m[kld] = ", 0.0005141449271819395],
  Editable->False]], "Print",
 CellChangeTimes->{3.427035566484228*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "715000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 715000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427038206678017*^9}],

Cell[BoxData["0.027441536126980304`"], "Print",
 CellChangeTimes->{3.427038206737628*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "715000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0004543369675356191`"}],
  SequenceForm[715000, " m[kld] = ", 0.0004543369675356191],
  Editable->False]], "Print",
 CellChangeTimes->{3.427038206779717*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "725000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 725000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427040843278217*^9}],

Cell[BoxData["0.025264171537836222`"], "Print",
 CellChangeTimes->{3.427040843339829*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "725000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0004311480618323151`"}],
  SequenceForm[725000, " m[kld] = ", 0.0004311480618323151],
  Editable->False]], "Print",
 CellChangeTimes->{3.42704084338608*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "735000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 735000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427043489643741*^9}],

Cell[BoxData["0.023510877871810498`"], "Print",
 CellChangeTimes->{3.427043489705693*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "735000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0003834177996199613`"}],
  SequenceForm[735000, " m[kld] = ", 0.0003834177996199613],
  Editable->False]], "Print",
 CellChangeTimes->{3.427043489753831*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "745000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 745000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427046131282971*^9}],

Cell[BoxData["0.021195453908139816`"], "Print",
 CellChangeTimes->{3.427046131345961*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "745000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0003438682388351466`"}],
  SequenceForm[745000, " m[kld] = ", 0.0003438682388351466],
  Editable->False]], "Print",
 CellChangeTimes->{3.427046131391677*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "755000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 755000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427048775220272*^9}],

Cell[BoxData["0.02347419719798005`"], "Print",
 CellChangeTimes->{3.427048775281571*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "755000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0005201370626423979`"}],
  SequenceForm[755000, " m[kld] = ", 0.0005201370626423979],
  Editable->False]], "Print",
 CellChangeTimes->{3.427048775325056*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "765000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 765000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4270514165402*^9}],

Cell[BoxData["0.022083426219631774`"], "Print",
 CellChangeTimes->{3.427051416601502*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "765000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0004552696842560408`"}],
  SequenceForm[765000, " m[kld] = ", 0.0004552696842560408],
  Editable->False]], "Print",
 CellChangeTimes->{3.427051416650418*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "775000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 775000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42705405166995*^9}],

Cell[BoxData["0.020432647341875998`"], "Print",
 CellChangeTimes->{3.427054051733794*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "775000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.000420838191833296`"}],
  SequenceForm[775000, " m[kld] = ", 0.000420838191833296],
  Editable->False]], "Print",
 CellChangeTimes->{3.427054051777871*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "785000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 785000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427056683265174*^9}],

Cell[BoxData["0.021088600975996297`"], "Print",
 CellChangeTimes->{3.427056683326972*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "785000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0005417391228826956`"}],
  SequenceForm[785000, " m[kld] = ", 0.0005417391228826956],
  Editable->False]], "Print",
 CellChangeTimes->{3.427056683375104*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "795000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 795000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427059329393312*^9}],

Cell[BoxData["0.021537878105785446`"], "Print",
 CellChangeTimes->{3.427059329454554*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "795000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0005381588448024366`"}],
  SequenceForm[795000, " m[kld] = ", 0.0005381588448024366],
  Editable->False]], "Print",
 CellChangeTimes->{3.427059329504667*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "805000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 805000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427061970403648*^9}],

Cell[BoxData["0.02006708278847147`"], "Print",
 CellChangeTimes->{3.427061970465526*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "805000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00047989609444184177`"}],
  SequenceForm[805000, " m[kld] = ", 0.00047989609444184177`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427061970512818*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "815000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 815000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427064612815636*^9}],

Cell[BoxData["0.019730237032790088`"], "Print",
 CellChangeTimes->{3.427064612878574*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "815000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0003803524099021678`"}],
  SequenceForm[815000, " m[kld] = ", 0.0003803524099021678],
  Editable->False]], "Print",
 CellChangeTimes->{3.427064612926135*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "825000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 825000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427067241133415*^9}],

Cell[BoxData["0.01838565791851532`"], "Print",
 CellChangeTimes->{3.427067241195144*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "825000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0003578240182966772`"}],
  SequenceForm[825000, " m[kld] = ", 0.0003578240182966772],
  Editable->False]], "Print",
 CellChangeTimes->{3.427067241240131*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "835000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 835000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427069886173792*^9}],

Cell[BoxData["0.019417071841088984`"], "Print",
 CellChangeTimes->{3.427069886237797*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "835000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00036104260514793014`"}],
  SequenceForm[835000, " m[kld] = ", 0.00036104260514793014`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427069886282545*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "845000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 845000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427072529999226*^9}],

Cell[BoxData["0.019636949660119973`"], "Print",
 CellChangeTimes->{3.427072530062564*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "845000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0003825076955326648`"}],
  SequenceForm[845000, " m[kld] = ", 0.0003825076955326648],
  Editable->False]], "Print",
 CellChangeTimes->{3.427072530109638*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "855000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 855000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427075161041249*^9}],

Cell[BoxData["0.020790565811435124`"], "Print",
 CellChangeTimes->{3.427075161102801*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "855000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0004165037517194095`"}],
  SequenceForm[855000, " m[kld] = ", 0.0004165037517194095],
  Editable->False]], "Print",
 CellChangeTimes->{3.427075161152603*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "865000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 865000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427077797737965*^9}],

Cell[BoxData["0.01875426521966872`"], "Print",
 CellChangeTimes->{3.42707779779992*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "865000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00034876964238096116`"}],
  SequenceForm[865000, " m[kld] = ", 0.00034876964238096116`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427077797846951*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "875000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 875000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427080440501379*^9}],

Cell[BoxData["0.01787522535734376`"], "Print",
 CellChangeTimes->{3.427080440563364*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "875000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00031039371157833646`"}],
  SequenceForm[875000, " m[kld] = ", 0.00031039371157833646`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427080440610624*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "885000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 885000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427083090850636*^9}],

Cell[BoxData["0.017104808284630346`"], "Print",
 CellChangeTimes->{3.427083090912229*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "885000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.000278136587568165`"}],
  SequenceForm[885000, " m[kld] = ", 0.000278136587568165],
  Editable->False]], "Print",
 CellChangeTimes->{3.42708309095679*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "895000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 895000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427085739192126*^9}],

Cell[BoxData["0.01511113733247238`"], "Print",
 CellChangeTimes->{3.4270857392553368`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "895000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0002443491800131824`"}],
  SequenceForm[895000, " m[kld] = ", 0.0002443491800131824],
  Editable->False]], "Print",
 CellChangeTimes->{3.427085739301008*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "905000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 905000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427088375932253*^9}],

Cell[BoxData["0.013679596616727019`"], "Print",
 CellChangeTimes->{3.427088375996379*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "905000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00022365658464899691`"}],
  SequenceForm[905000, " m[kld] = ", 0.00022365658464899691`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427088376041096*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "915000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 915000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427091010077542*^9}],

Cell[BoxData["0.01431597435397114`"], "Print",
 CellChangeTimes->{3.427091010138898*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "915000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.000249465646989403`"}],
  SequenceForm[915000, " m[kld] = ", 0.000249465646989403],
  Editable->False]], "Print",
 CellChangeTimes->{3.427091010186419*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "925000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 925000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427093649919734*^9}],

Cell[BoxData["0.013271006709094979`"], "Print",
 CellChangeTimes->{3.427093649983699*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "925000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00020951379954943736`"}],
  SequenceForm[925000, " m[kld] = ", 0.00020951379954943736`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427093650029717*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "935000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 935000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427096292234422*^9}],

Cell[BoxData["0.013262510954019313`"], "Print",
 CellChangeTimes->{3.427096292298773*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "935000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00020439438304723648`"}],
  SequenceForm[935000, " m[kld] = ", 0.00020439438304723648`],
  Editable->False]], "Print",
 CellChangeTimes->{3.42709629234638*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "945000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 945000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427098930359692*^9}],

Cell[BoxData["0.012379561691762575`"], "Print",
 CellChangeTimes->{3.427098930421881*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "945000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00021799146152595968`"}],
  SequenceForm[945000, " m[kld] = ", 0.00021799146152595968`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427098930470234*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "955000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 955000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427101573898413*^9}],

Cell[BoxData["0.012610162611068954`"], "Print",
 CellChangeTimes->{3.427101573960177*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "955000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00020523972721054638`"}],
  SequenceForm[955000, " m[kld] = ", 0.00020523972721054638`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427101574007142*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "965000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 965000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427104214552534*^9}],

Cell[BoxData["0.013443677881121552`"], "Print",
 CellChangeTimes->{3.427104214615705*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "965000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0001969481079036534`"}],
  SequenceForm[965000, " m[kld] = ", 0.0001969481079036534],
  Editable->False]], "Print",
 CellChangeTimes->{3.427104214658986*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "975000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 975000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427106848723558*^9}],

Cell[BoxData["0.012366013288372169`"], "Print",
 CellChangeTimes->{3.42710684878533*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "975000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00015792489641941246`"}],
  SequenceForm[975000, " m[kld] = ", 0.00015792489641941246`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427106848831003*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "985000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 985000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427109494100123*^9}],

Cell[BoxData["0.011020518316337657`"], "Print",
 CellChangeTimes->{3.427109494170733*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "985000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00014171119134206956`"}],
  SequenceForm[985000, " m[kld] = ", 0.00014171119134206956`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427109494212692*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "995000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 995000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427112137725855*^9}],

Cell[BoxData["0.011193255589032058`"], "Print",
 CellChangeTimes->{3.427112137787574*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "995000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00013953127893014515`"}],
  SequenceForm[995000, " m[kld] = ", 0.00013953127893014515`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427112137851882*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1005000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1005000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427114779773047*^9}],

Cell[BoxData["0.010946498609793354`"], "Print",
 CellChangeTimes->{3.427114779835847*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1005000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00013219017595388118`"}],
  SequenceForm[1005000, " m[kld] = ", 0.00013219017595388118`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427114779882772*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1015000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1015000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427117417703187*^9}],

Cell[BoxData["0.011587880152701957`"], "Print",
 CellChangeTimes->{3.427117417769185*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1015000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0001295972359709312`"}],
  SequenceForm[1015000, " m[kld] = ", 0.0001295972359709312],
  Editable->False]], "Print",
 CellChangeTimes->{3.427117417813326*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1025000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1025000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427120064016142*^9}],

Cell[BoxData["0.011295029373424081`"], "Print",
 CellChangeTimes->{3.427120064078919*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1025000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00013533803926462013`"}],
  SequenceForm[1025000, " m[kld] = ", 0.00013533803926462013`],
  Editable->False]], "Print",
 CellChangeTimes->{3.42712006412439*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1035000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1035000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427122705693211*^9}],

Cell[BoxData["0.011455480393622208`"], "Print",
 CellChangeTimes->{3.427122705755476*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1035000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00012693371548084989`"}],
  SequenceForm[1035000, " m[kld] = ", 0.00012693371548084989`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427122705799924*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1045000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1045000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427125340407027*^9}],

Cell[BoxData["0.012008456786111038`"], "Print",
 CellChangeTimes->{3.427125340470671*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1045000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00012573415230826787`"}],
  SequenceForm[1045000, " m[kld] = ", 0.00012573415230826787`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427125340517253*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1055000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1055000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427127985072793*^9}],

Cell[BoxData["0.013989221988047085`"], "Print",
 CellChangeTimes->{3.42712798513576*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1055000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00013553983328634398`"}],
  SequenceForm[1055000, " m[kld] = ", 0.00013553983328634398`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427127985181959*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1065000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1065000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427130626612181*^9}],

Cell[BoxData["0.01593261443794891`"], "Print",
 CellChangeTimes->{3.427130626675119*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1065000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00015155274613943678`"}],
  SequenceForm[1065000, " m[kld] = ", 0.00015155274613943678`],
  Editable->False]], "Print",
 CellChangeTimes->{3.42713062672481*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1075000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1075000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427133268447076*^9}],

Cell[BoxData["0.01651058330334723`"], "Print",
 CellChangeTimes->{3.427133268511564*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1075000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0001672183054599621`"}],
  SequenceForm[1075000, " m[kld] = ", 0.0001672183054599621],
  Editable->False]], "Print",
 CellChangeTimes->{3.427133268554992*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1085000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1085000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427135917512392*^9}],

Cell[BoxData["0.012658578822699829`"], "Print",
 CellChangeTimes->{3.427135917574495*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1085000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00015204024797396576`"}],
  SequenceForm[1085000, " m[kld] = ", 0.00015204024797396576`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427135917619036*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1095000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1095000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427138554504914*^9}],

Cell[BoxData["0.012435268245966635`"], "Print",
 CellChangeTimes->{3.42713855457132*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1095000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00017328873083156376`"}],
  SequenceForm[1095000, " m[kld] = ", 0.00017328873083156376`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427138554617893*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1105000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1105000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427141209022901*^9}],

Cell[BoxData["0.012521501548343306`"], "Print",
 CellChangeTimes->{3.427141209085433*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1105000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00018921487291220733`"}],
  SequenceForm[1105000, " m[kld] = ", 0.00018921487291220733`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427141209127656*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1115000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1115000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427143857096897*^9}],

Cell[BoxData["0.011021345075136857`"], "Print",
 CellChangeTimes->{3.427143857159616*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1115000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0002072095526462236`"}],
  SequenceForm[1115000, " m[kld] = ", 0.0002072095526462236],
  Editable->False]], "Print",
 CellChangeTimes->{3.427143857205097*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1125000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1125000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42714649916384*^9}],

Cell[BoxData["0.010532824682550818`"], "Print",
 CellChangeTimes->{3.427146499226207*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1125000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00017524946725049588`"}],
  SequenceForm[1125000, " m[kld] = ", 0.00017524946725049588`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427146499271242*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1135000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1135000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427149139744145*^9}],

Cell[BoxData["0.010416307603979935`"], "Print",
 CellChangeTimes->{3.427149139807345*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1135000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0001788184536438791`"}],
  SequenceForm[1135000, " m[kld] = ", 0.0001788184536438791],
  Editable->False]], "Print",
 CellChangeTimes->{3.427149139853039*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1145000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1145000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427151781297322*^9}],

Cell[BoxData["0.01614976224071976`"], "Print",
 CellChangeTimes->{3.427151781361573*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1145000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00027086688068378944`"}],
  SequenceForm[1145000, " m[kld] = ", 0.00027086688068378944`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427151781407434*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1155000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1155000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427154425242413*^9}],

Cell[BoxData["0.017907482132548752`"], "Print",
 CellChangeTimes->{3.427154425304005*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1155000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00028975817483706484`"}],
  SequenceForm[1155000, " m[kld] = ", 0.00028975817483706484`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427154425349688*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1165000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1165000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427157077026192*^9}],

Cell[BoxData["0.017523487703096335`"], "Print",
 CellChangeTimes->{3.427157077089727*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1165000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00025893030371301734`"}],
  SequenceForm[1165000, " m[kld] = ", 0.00025893030371301734`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427157077137787*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1175000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1175000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427159718424277*^9}],

Cell[BoxData["0.016766718854109464`"], "Print",
 CellChangeTimes->{3.4271597184876*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1175000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00023424298917242248`"}],
  SequenceForm[1175000, " m[kld] = ", 0.00023424298917242248`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427159718536342*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1185000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1185000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427162368120711*^9}],

Cell[BoxData["0.015015928514920729`"], "Print",
 CellChangeTimes->{3.427162368183908*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1185000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00019261043202810986`"}],
  SequenceForm[1185000, " m[kld] = ", 0.00019261043202810986`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427162368232969*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1195000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1195000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427165009139675*^9}],

Cell[BoxData["0.013297084349737809`"], "Print",
 CellChangeTimes->{3.427165009203218*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1195000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00016025980177773136`"}],
  SequenceForm[1195000, " m[kld] = ", 0.00016025980177773136`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427165009246536*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1205000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1205000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42716765420788*^9}],

Cell[BoxData["0.01535474663776945`"], "Print",
 CellChangeTimes->{3.427167654270725*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1205000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0001995323806497116`"}],
  SequenceForm[1205000, " m[kld] = ", 0.0001995323806497116],
  Editable->False]], "Print",
 CellChangeTimes->{3.427167654319929*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1215000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1215000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427170293562835*^9}],

Cell[BoxData["0.013694396011318194`"], "Print",
 CellChangeTimes->{3.427170293625435*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1215000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00017301558505585627`"}],
  SequenceForm[1215000, " m[kld] = ", 0.00017301558505585627`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427170293670665*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1225000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1225000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427172934027867*^9}],

Cell[BoxData["0.012102223428654968`"], "Print",
 CellChangeTimes->{3.42717293409152*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1225000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00014370227849200325`"}],
  SequenceForm[1225000, " m[kld] = ", 0.00014370227849200325`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427172934135819*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1235000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1235000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427175576550641*^9}],

Cell[BoxData["0.010632987406247046`"], "Print",
 CellChangeTimes->{3.427175576613604*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1235000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00012276494499903137`"}],
  SequenceForm[1235000, " m[kld] = ", 0.00012276494499903137`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427175576660106*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1245000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1245000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427178226032344*^9}],

Cell[BoxData["0.009211509161749926`"], "Print",
 CellChangeTimes->{3.427178226096173*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1245000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00010272631434656452`"}],
  SequenceForm[1245000, " m[kld] = ", 0.00010272631434656452`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427178226144967*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1255000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1255000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427180864256715*^9}],

Cell[BoxData["0.009659351749599504`"], "Print",
 CellChangeTimes->{3.427180864322559*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1255000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00010365277498295116`"}],
  SequenceForm[1255000, " m[kld] = ", 0.00010365277498295116`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427180864370184*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1265000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1265000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427183509355044*^9}],

Cell[BoxData["0.009696931704599177`"], "Print",
 CellChangeTimes->{3.427183509420368*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1265000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00009884973397862126`"}],
  SequenceForm[1265000, " m[kld] = ", 0.00009884973397862126],
  Editable->False]], "Print",
 CellChangeTimes->{3.427183509465882*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1275000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1275000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42718614731672*^9}],

Cell[BoxData["0.010151862319151078`"], "Print",
 CellChangeTimes->{3.427186147380584*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1275000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00010321052469303481`"}],
  SequenceForm[1275000, " m[kld] = ", 0.00010321052469303481`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427186147429038*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1285000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1285000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42718878841796*^9}],

Cell[BoxData["0.00959670084408007`"], "Print",
 CellChangeTimes->{3.427188788482892*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1285000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00009832816473243261`"}],
  SequenceForm[1285000, " m[kld] = ", 0.00009832816473243261],
  Editable->False]], "Print",
 CellChangeTimes->{3.427188788529486*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1295000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1295000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427191427632248*^9}],

Cell[BoxData["0.008975249261354817`"], "Print",
 CellChangeTimes->{3.427191427694976*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1295000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00007911913219510691`"}],
  SequenceForm[1295000, " m[kld] = ", 0.00007911913219510691],
  Editable->False]], "Print",
 CellChangeTimes->{3.427191427744702*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1305000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1305000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427194069768565*^9}],

Cell[BoxData["0.010325777490519328`"], "Print",
 CellChangeTimes->{3.427194069832995*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1305000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00009208499898249228`"}],
  SequenceForm[1305000, " m[kld] = ", 0.00009208499898249228],
  Editable->False]], "Print",
 CellChangeTimes->{3.427194069880098*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1315000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1315000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427196709485764*^9}],

Cell[BoxData["0.009477148235588873`"], "Print",
 CellChangeTimes->{3.427196709565006*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1315000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00007474448399849855`"}],
  SequenceForm[1315000, " m[kld] = ", 0.00007474448399849855],
  Editable->False]], "Print",
 CellChangeTimes->{3.4271967096123*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1325000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1325000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427199351556956*^9}],

Cell[BoxData["0.00818105727855628`"], "Print",
 CellChangeTimes->{3.427199351622979*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1325000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00006391175615298668`"}],
  SequenceForm[1325000, " m[kld] = ", 0.00006391175615298668],
  Editable->False]], "Print",
 CellChangeTimes->{3.427199351666365*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1335000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1335000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427201987023039*^9}],

Cell[BoxData["0.010020641214232406`"], "Print",
 CellChangeTimes->{3.427201987089394*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1335000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00008295409615775374`"}],
  SequenceForm[1335000, " m[kld] = ", 0.00008295409615775374],
  Editable->False]], "Print",
 CellChangeTimes->{3.427201987134802*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1345000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1345000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427204622897376*^9}],

Cell[BoxData["0.013229497634704157`"], "Print",
 CellChangeTimes->{3.427204622958898*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1345000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00012801210547203125`"}],
  SequenceForm[1345000, " m[kld] = ", 0.00012801210547203125`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427204623004338*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1355000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1355000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427207264048693*^9}],

Cell[BoxData["0.011549226674124558`"], "Print",
 CellChangeTimes->{3.4272072641121*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1355000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0001064968877904495`"}],
  SequenceForm[1355000, " m[kld] = ", 0.0001064968877904495],
  Editable->False]], "Print",
 CellChangeTimes->{3.427207264157549*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1365000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1365000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427209905861393*^9}],

Cell[BoxData["0.010643025416579466`"], "Print",
 CellChangeTimes->{3.427209905924784*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1365000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00009464682514392366`"}],
  SequenceForm[1365000, " m[kld] = ", 0.00009464682514392366],
  Editable->False]], "Print",
 CellChangeTimes->{3.427209905973253*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1375000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1375000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427212543704092*^9}],

Cell[BoxData["0.01372816240884045`"], "Print",
 CellChangeTimes->{3.427212543770426*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1375000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0001393090622621406`"}],
  SequenceForm[1375000, " m[kld] = ", 0.0001393090622621406],
  Editable->False]], "Print",
 CellChangeTimes->{3.427212543815678*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1385000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1385000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427215183757093*^9}],

Cell[BoxData["0.01231347123148907`"], "Print",
 CellChangeTimes->{3.427215183820082*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1385000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00012433635216347805`"}],
  SequenceForm[1385000, " m[kld] = ", 0.00012433635216347805`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427215183863924*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1395000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1395000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427217823265884*^9}],

Cell[BoxData["0.010920202815840774`"], "Print",
 CellChangeTimes->{3.427217823329365*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1395000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00010574259990449138`"}],
  SequenceForm[1395000, " m[kld] = ", 0.00010574259990449138`],
  Editable->False]], "Print",
 CellChangeTimes->{3.427217823378722*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1405000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1405000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427220466278782*^9}],

Cell[BoxData["0.009536122844632539`"], "Print",
 CellChangeTimes->{3.427220466341997*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1405000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0000888011674414215`"}],
  SequenceForm[1405000, " m[kld] = ", 0.0000888011674414215],
  Editable->False]], "Print",
 CellChangeTimes->{3.427220466388892*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1415000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1415000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427223103391786*^9}],

Cell[BoxData["0.008183023756164948`"], "Print",
 CellChangeTimes->{3.427223103458461*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1415000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.0000758464787679796`"}],
  SequenceForm[1415000, " m[kld] = ", 0.0000758464787679796],
  Editable->False]], "Print",
 CellChangeTimes->{3.427223103503975*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1425000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1425000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427225741673601*^9}],

Cell[BoxData["0.006882788412700347`"], "Print",
 CellChangeTimes->{3.427225741736109*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1425000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00006566041084575589`"}],
  SequenceForm[1425000, " m[kld] = ", 0.00006566041084575589],
  Editable->False]], "Print",
 CellChangeTimes->{3.427225741782583*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1435000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1435000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427228391487674*^9}],

Cell[BoxData["0.006044002148459071`"], "Print",
 CellChangeTimes->{3.427228391556242*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1435000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00006039767040032374`"}],
  SequenceForm[1435000, " m[kld] = ", 0.00006039767040032374],
  Editable->False]], "Print",
 CellChangeTimes->{3.427228391602061*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1445000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1445000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427231038471416*^9}],

Cell[BoxData["0.006144953922635588`"], "Print",
 CellChangeTimes->{3.427231038535127*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1445000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00005501325741956245`"}],
  SequenceForm[1445000, " m[kld] = ", 0.00005501325741956245],
  Editable->False]], "Print",
 CellChangeTimes->{3.427231038582749*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1455000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1455000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42723367766824*^9}],

Cell[BoxData["0.006246582428648284`"], "Print",
 CellChangeTimes->{3.427233677730459*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1455000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00005128396986620255`"}],
  SequenceForm[1455000, " m[kld] = ", 0.00005128396986620255],
  Editable->False]], "Print",
 CellChangeTimes->{3.427233677775964*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1465000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1465000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427236312933294*^9}],

Cell[BoxData["0.006217354210235365`"], "Print",
 CellChangeTimes->{3.427236312997707*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1465000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00006115880927940121`"}],
  SequenceForm[1465000, " m[kld] = ", 0.00006115880927940121],
  Editable->False]], "Print",
 CellChangeTimes->{3.427236313041841*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1475000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1475000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.427238953240204*^9}],

Cell[BoxData["0.006439568312041011`"], "Print",
 CellChangeTimes->{3.427238953303214*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1475000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00006189355507332713`"}],
  SequenceForm[1475000, " m[kld] = ", 0.00006189355507332713],
  Editable->False]], "Print",
 CellChangeTimes->{3.427238953351955*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"writing est at <\"\>", "\[InvisibleSpace]", "1485000", 
   "\[InvisibleSpace]", "\<\">\"\>"}],
  SequenceForm["writing est at <", 1485000, ">"],
  Editable->False]], "Print",
 CellChangeTimes->{3.42724159871818*^9}],

Cell[BoxData["0.0064702478009699416`"], "Print",
 CellChangeTimes->{3.427241598782392*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1485000", "\[InvisibleSpace]", "\<\" m[kld] = \"\>", "\[InvisibleSpace]", 
   "0.00007363512341937416`"}],
  SequenceForm[1485000, " m[kld] = ", 0.00007363512341937416],
  Editable->False]], "Print",
 CellChangeTimes->{3.4272415988275*^9}]
}, Open  ]],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.427243524640244*^9}]
}, Open  ]]
},
WindowSize->{894, 994},
WindowMargins->{{Automatic, 114}, {5, Automatic}},
ShowSelection->True,
FrontEndVersion->"6.0 for Linux x86 (32-bit) (April 20, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[569, 21, 1356, 37, 209, "Input"],
Cell[CellGroupData[{
Cell[1950, 62, 22582, 622, 1331, "Input"],
Cell[CellGroupData[{
Cell[24557, 688, 99, 1, 24, "Print"],
Cell[24659, 691, 88, 1, 24, "Print"],
Cell[24750, 694, 279, 7, 24, "Print"],
Cell[25032, 703, 86, 1, 24, "Print"],
Cell[25121, 706, 282, 7, 24, "Print"],
Cell[25406, 715, 88, 1, 24, "Print"],
Cell[25497, 718, 280, 7, 24, "Print"],
Cell[25780, 727, 88, 1, 24, "Print"],
Cell[25871, 730, 284, 7, 24, "Print"],
Cell[26158, 739, 88, 1, 24, "Print"],
Cell[26249, 742, 284, 7, 24, "Print"],
Cell[26536, 751, 88, 1, 24, "Print"],
Cell[26627, 754, 286, 7, 24, "Print"],
Cell[26916, 763, 88, 1, 24, "Print"],
Cell[27007, 766, 286, 7, 24, "Print"],
Cell[27296, 775, 87, 1, 24, "Print"],
Cell[27386, 778, 283, 7, 24, "Print"],
Cell[27672, 787, 88, 1, 24, "Print"],
Cell[27763, 790, 280, 7, 24, "Print"],
Cell[28046, 799, 88, 1, 24, "Print"],
Cell[28137, 802, 286, 7, 24, "Print"],
Cell[28426, 811, 88, 1, 24, "Print"],
Cell[28517, 814, 282, 7, 24, "Print"],
Cell[28802, 823, 88, 1, 24, "Print"],
Cell[28893, 826, 286, 7, 24, "Print"],
Cell[29182, 835, 88, 1, 24, "Print"],
Cell[29273, 838, 281, 7, 24, "Print"],
Cell[29557, 847, 88, 1, 24, "Print"],
Cell[29648, 850, 285, 7, 24, "Print"],
Cell[29936, 859, 88, 1, 24, "Print"],
Cell[30027, 862, 283, 7, 24, "Print"],
Cell[30313, 871, 263, 6, 24, "Print"],
Cell[30579, 879, 88, 1, 24, "Print"],
Cell[30670, 882, 283, 7, 24, "Print"],
Cell[30956, 891, 263, 6, 24, "Print"],
Cell[31222, 899, 87, 1, 24, "Print"],
Cell[31312, 902, 286, 7, 24, "Print"],
Cell[31601, 911, 261, 6, 24, "Print"],
Cell[31865, 919, 86, 1, 24, "Print"],
Cell[31954, 922, 279, 7, 24, "Print"],
Cell[32236, 931, 261, 6, 24, "Print"],
Cell[32500, 939, 88, 1, 24, "Print"],
Cell[32591, 942, 281, 7, 24, "Print"],
Cell[32875, 951, 263, 6, 24, "Print"],
Cell[33141, 959, 87, 1, 24, "Print"],
Cell[33231, 962, 286, 7, 24, "Print"],
Cell[33520, 971, 263, 6, 24, "Print"],
Cell[33786, 979, 88, 1, 24, "Print"],
Cell[33877, 982, 286, 7, 24, "Print"],
Cell[34166, 991, 263, 6, 24, "Print"],
Cell[34432, 999, 88, 1, 24, "Print"],
Cell[34523, 1002, 279, 7, 24, "Print"],
Cell[34805, 1011, 263, 6, 24, "Print"],
Cell[35071, 1019, 88, 1, 24, "Print"],
Cell[35162, 1022, 285, 7, 24, "Print"],
Cell[35450, 1031, 263, 6, 24, "Print"],
Cell[35716, 1039, 88, 1, 24, "Print"],
Cell[35807, 1042, 286, 7, 24, "Print"],
Cell[36096, 1051, 263, 6, 24, "Print"],
Cell[36362, 1059, 87, 1, 24, "Print"],
Cell[36452, 1062, 285, 7, 24, "Print"],
Cell[36740, 1071, 262, 6, 24, "Print"],
Cell[37005, 1079, 88, 1, 24, "Print"],
Cell[37096, 1082, 286, 7, 24, "Print"],
Cell[37385, 1091, 263, 6, 24, "Print"],
Cell[37651, 1099, 88, 1, 24, "Print"],
Cell[37742, 1102, 286, 7, 24, "Print"],
Cell[38031, 1111, 263, 6, 24, "Print"],
Cell[38297, 1119, 86, 1, 24, "Print"],
Cell[38386, 1122, 286, 7, 24, "Print"],
Cell[38675, 1131, 263, 6, 24, "Print"],
Cell[38941, 1139, 89, 1, 24, "Print"],
Cell[39033, 1142, 286, 7, 24, "Print"],
Cell[39322, 1151, 263, 6, 24, "Print"],
Cell[39588, 1159, 88, 1, 24, "Print"],
Cell[39679, 1162, 283, 7, 24, "Print"],
Cell[39965, 1171, 263, 6, 24, "Print"],
Cell[40231, 1179, 89, 1, 24, "Print"],
Cell[40323, 1182, 286, 7, 24, "Print"],
Cell[40612, 1191, 262, 6, 24, "Print"],
Cell[40877, 1199, 88, 1, 24, "Print"],
Cell[40968, 1202, 284, 7, 24, "Print"],
Cell[41255, 1211, 263, 6, 24, "Print"],
Cell[41521, 1219, 89, 1, 24, "Print"],
Cell[41613, 1222, 286, 7, 24, "Print"],
Cell[41902, 1231, 263, 6, 24, "Print"],
Cell[42168, 1239, 87, 1, 24, "Print"],
Cell[42258, 1242, 283, 7, 24, "Print"],
Cell[42544, 1251, 263, 6, 24, "Print"],
Cell[42810, 1259, 88, 1, 24, "Print"],
Cell[42901, 1262, 286, 7, 24, "Print"],
Cell[43190, 1271, 263, 6, 24, "Print"],
Cell[43456, 1279, 88, 1, 24, "Print"],
Cell[43547, 1282, 285, 7, 24, "Print"],
Cell[43835, 1291, 263, 6, 24, "Print"],
Cell[44101, 1299, 88, 1, 24, "Print"],
Cell[44192, 1302, 286, 7, 24, "Print"],
Cell[44481, 1311, 263, 6, 24, "Print"],
Cell[44747, 1319, 89, 1, 24, "Print"],
Cell[44839, 1322, 286, 7, 24, "Print"],
Cell[45128, 1331, 261, 6, 24, "Print"],
Cell[45392, 1339, 88, 1, 24, "Print"],
Cell[45483, 1342, 286, 7, 24, "Print"],
Cell[45772, 1351, 263, 6, 24, "Print"],
Cell[46038, 1359, 88, 1, 24, "Print"],
Cell[46129, 1362, 284, 7, 24, "Print"],
Cell[46416, 1371, 263, 6, 24, "Print"],
Cell[46682, 1379, 88, 1, 24, "Print"],
Cell[46773, 1382, 285, 7, 24, "Print"],
Cell[47061, 1391, 262, 6, 24, "Print"],
Cell[47326, 1399, 88, 1, 24, "Print"],
Cell[47417, 1402, 285, 7, 24, "Print"],
Cell[47705, 1411, 263, 6, 24, "Print"],
Cell[47971, 1419, 88, 1, 24, "Print"],
Cell[48062, 1422, 283, 7, 24, "Print"],
Cell[48348, 1431, 263, 6, 24, "Print"],
Cell[48614, 1439, 88, 1, 24, "Print"],
Cell[48705, 1442, 284, 7, 24, "Print"],
Cell[48992, 1451, 263, 6, 24, "Print"],
Cell[49258, 1459, 88, 1, 24, "Print"],
Cell[49349, 1462, 285, 7, 24, "Print"],
Cell[49637, 1471, 263, 6, 24, "Print"],
Cell[49903, 1479, 88, 1, 24, "Print"],
Cell[49994, 1482, 282, 7, 24, "Print"],
Cell[50279, 1491, 262, 6, 24, "Print"],
Cell[50544, 1499, 88, 1, 24, "Print"],
Cell[50635, 1502, 283, 7, 24, "Print"],
Cell[50921, 1511, 263, 6, 24, "Print"],
Cell[51187, 1519, 89, 1, 24, "Print"],
Cell[51279, 1522, 288, 7, 24, "Print"],
Cell[51570, 1531, 263, 6, 24, "Print"],
Cell[51836, 1539, 88, 1, 24, "Print"],
Cell[51927, 1542, 285, 7, 24, "Print"],
Cell[52215, 1551, 263, 6, 24, "Print"],
Cell[52481, 1559, 89, 1, 24, "Print"],
Cell[52573, 1562, 285, 7, 24, "Print"],
Cell[52861, 1571, 263, 6, 24, "Print"],
Cell[53127, 1579, 89, 1, 24, "Print"],
Cell[53219, 1582, 285, 7, 24, "Print"],
Cell[53507, 1591, 263, 6, 24, "Print"],
Cell[53773, 1599, 89, 1, 24, "Print"],
Cell[53865, 1602, 288, 7, 24, "Print"],
Cell[54156, 1611, 263, 6, 24, "Print"],
Cell[54422, 1619, 88, 1, 24, "Print"],
Cell[54513, 1622, 285, 7, 24, "Print"],
Cell[54801, 1631, 263, 6, 24, "Print"],
Cell[55067, 1639, 89, 1, 24, "Print"],
Cell[55159, 1642, 288, 7, 24, "Print"],
Cell[55450, 1651, 263, 6, 24, "Print"],
Cell[55716, 1659, 89, 1, 24, "Print"],
Cell[55808, 1662, 288, 7, 24, "Print"],
Cell[56099, 1671, 263, 6, 24, "Print"],
Cell[56365, 1679, 88, 1, 24, "Print"],
Cell[56456, 1682, 285, 7, 24, "Print"],
Cell[56744, 1691, 263, 6, 24, "Print"],
Cell[57010, 1699, 89, 1, 24, "Print"],
Cell[57102, 1702, 285, 7, 24, "Print"],
Cell[57390, 1711, 263, 6, 24, "Print"],
Cell[57656, 1719, 89, 1, 24, "Print"],
Cell[57748, 1722, 285, 7, 24, "Print"],
Cell[58036, 1731, 262, 6, 24, "Print"],
Cell[58301, 1739, 89, 1, 24, "Print"],
Cell[58393, 1742, 285, 7, 24, "Print"],
Cell[58681, 1751, 263, 6, 24, "Print"],
Cell[58947, 1759, 89, 1, 24, "Print"],
Cell[59039, 1762, 285, 7, 24, "Print"],
Cell[59327, 1771, 263, 6, 24, "Print"],
Cell[59593, 1779, 89, 1, 24, "Print"],
Cell[59685, 1782, 283, 7, 24, "Print"],
Cell[59971, 1791, 263, 6, 24, "Print"],
Cell[60237, 1799, 88, 1, 24, "Print"],
Cell[60328, 1802, 288, 7, 24, "Print"],
Cell[60619, 1811, 262, 6, 24, "Print"],
Cell[60884, 1819, 89, 1, 24, "Print"],
Cell[60976, 1822, 288, 7, 24, "Print"],
Cell[61267, 1831, 263, 6, 24, "Print"],
Cell[61533, 1839, 89, 1, 24, "Print"],
Cell[61625, 1842, 288, 7, 24, "Print"],
Cell[61916, 1851, 263, 6, 24, "Print"],
Cell[62182, 1859, 89, 1, 24, "Print"],
Cell[62274, 1862, 285, 7, 24, "Print"],
Cell[62562, 1871, 263, 6, 24, "Print"],
Cell[62828, 1879, 89, 1, 24, "Print"],
Cell[62920, 1882, 285, 7, 24, "Print"],
Cell[63208, 1891, 263, 6, 24, "Print"],
Cell[63474, 1899, 89, 1, 24, "Print"],
Cell[63566, 1902, 285, 7, 24, "Print"],
Cell[63854, 1911, 263, 6, 24, "Print"],
Cell[64120, 1919, 89, 1, 24, "Print"],
Cell[64212, 1922, 284, 7, 24, "Print"],
Cell[64499, 1931, 263, 6, 24, "Print"],
Cell[64765, 1939, 89, 1, 24, "Print"],
Cell[64857, 1942, 285, 7, 24, "Print"],
Cell[65145, 1951, 263, 6, 24, "Print"],
Cell[65411, 1959, 89, 1, 24, "Print"],
Cell[65503, 1962, 285, 7, 24, "Print"],
Cell[65791, 1971, 263, 6, 24, "Print"],
Cell[66057, 1979, 88, 1, 24, "Print"],
Cell[66148, 1982, 285, 7, 24, "Print"],
Cell[66436, 1991, 261, 6, 24, "Print"],
Cell[66700, 1999, 89, 1, 24, "Print"],
Cell[66792, 2002, 285, 7, 24, "Print"],
Cell[67080, 2011, 262, 6, 24, "Print"],
Cell[67345, 2019, 89, 1, 24, "Print"],
Cell[67437, 2022, 283, 7, 24, "Print"],
Cell[67723, 2031, 263, 6, 24, "Print"],
Cell[67989, 2039, 89, 1, 24, "Print"],
Cell[68081, 2042, 285, 7, 24, "Print"],
Cell[68369, 2051, 263, 6, 24, "Print"],
Cell[68635, 2059, 89, 1, 24, "Print"],
Cell[68727, 2062, 285, 7, 24, "Print"],
Cell[69015, 2071, 263, 6, 24, "Print"],
Cell[69281, 2079, 88, 1, 24, "Print"],
Cell[69372, 2082, 288, 7, 24, "Print"],
Cell[69663, 2091, 263, 6, 24, "Print"],
Cell[69929, 2099, 89, 1, 24, "Print"],
Cell[70021, 2102, 285, 7, 24, "Print"],
Cell[70309, 2111, 263, 6, 24, "Print"],
Cell[70575, 2119, 88, 1, 24, "Print"],
Cell[70666, 2122, 285, 7, 24, "Print"],
Cell[70954, 2131, 263, 6, 24, "Print"],
Cell[71220, 2139, 89, 1, 24, "Print"],
Cell[71312, 2142, 288, 7, 24, "Print"],
Cell[71603, 2151, 263, 6, 24, "Print"],
Cell[71869, 2159, 89, 1, 24, "Print"],
Cell[71961, 2162, 285, 7, 24, "Print"],
Cell[72249, 2171, 263, 6, 24, "Print"],
Cell[72515, 2179, 89, 1, 24, "Print"],
Cell[72607, 2182, 285, 7, 24, "Print"],
Cell[72895, 2191, 263, 6, 24, "Print"],
Cell[73161, 2199, 87, 1, 24, "Print"],
Cell[73251, 2202, 288, 7, 24, "Print"],
Cell[73542, 2211, 263, 6, 24, "Print"],
Cell[73808, 2219, 88, 1, 24, "Print"],
Cell[73899, 2222, 288, 7, 24, "Print"],
Cell[74190, 2231, 263, 6, 24, "Print"],
Cell[74456, 2239, 89, 1, 24, "Print"],
Cell[74548, 2242, 282, 7, 24, "Print"],
Cell[74833, 2251, 263, 6, 24, "Print"],
Cell[75099, 2259, 90, 1, 24, "Print"],
Cell[75192, 2262, 285, 7, 24, "Print"],
Cell[75480, 2271, 263, 6, 24, "Print"],
Cell[75746, 2279, 89, 1, 24, "Print"],
Cell[75838, 2282, 288, 7, 24, "Print"],
Cell[76129, 2291, 263, 6, 24, "Print"],
Cell[76395, 2299, 88, 1, 24, "Print"],
Cell[76486, 2302, 283, 7, 24, "Print"],
Cell[76772, 2311, 263, 6, 24, "Print"],
Cell[77038, 2319, 89, 1, 24, "Print"],
Cell[77130, 2322, 288, 7, 24, "Print"],
Cell[77421, 2331, 263, 6, 24, "Print"],
Cell[77687, 2339, 89, 1, 24, "Print"],
Cell[77779, 2342, 287, 7, 24, "Print"],
Cell[78069, 2351, 263, 6, 24, "Print"],
Cell[78335, 2359, 89, 1, 24, "Print"],
Cell[78427, 2362, 288, 7, 24, "Print"],
Cell[78718, 2371, 263, 6, 24, "Print"],
Cell[78984, 2379, 89, 1, 24, "Print"],
Cell[79076, 2382, 288, 7, 24, "Print"],
Cell[79367, 2391, 263, 6, 24, "Print"],
Cell[79633, 2399, 89, 1, 24, "Print"],
Cell[79725, 2402, 285, 7, 24, "Print"],
Cell[80013, 2411, 263, 6, 24, "Print"],
Cell[80279, 2419, 88, 1, 24, "Print"],
Cell[80370, 2422, 288, 7, 24, "Print"],
Cell[80661, 2431, 263, 6, 24, "Print"],
Cell[80927, 2439, 89, 1, 24, "Print"],
Cell[81019, 2442, 288, 7, 24, "Print"],
Cell[81310, 2451, 263, 6, 24, "Print"],
Cell[81576, 2459, 89, 1, 24, "Print"],
Cell[81668, 2462, 288, 7, 24, "Print"],
Cell[81959, 2471, 265, 6, 24, "Print"],
Cell[82227, 2479, 89, 1, 24, "Print"],
Cell[82319, 2482, 290, 7, 24, "Print"],
Cell[82612, 2491, 265, 6, 24, "Print"],
Cell[82880, 2499, 89, 1, 24, "Print"],
Cell[82972, 2502, 287, 7, 24, "Print"],
Cell[83262, 2511, 265, 6, 24, "Print"],
Cell[83530, 2519, 89, 1, 24, "Print"],
Cell[83622, 2522, 289, 7, 24, "Print"],
Cell[83914, 2531, 265, 6, 24, "Print"],
Cell[84182, 2539, 89, 1, 24, "Print"],
Cell[84274, 2542, 290, 7, 24, "Print"],
Cell[84567, 2551, 265, 6, 24, "Print"],
Cell[84835, 2559, 89, 1, 24, "Print"],
Cell[84927, 2562, 290, 7, 24, "Print"],
Cell[85220, 2571, 265, 6, 24, "Print"],
Cell[85488, 2579, 88, 1, 24, "Print"],
Cell[85579, 2582, 290, 7, 24, "Print"],
Cell[85872, 2591, 265, 6, 24, "Print"],
Cell[86140, 2599, 88, 1, 24, "Print"],
Cell[86231, 2602, 289, 7, 24, "Print"],
Cell[86523, 2611, 265, 6, 24, "Print"],
Cell[86791, 2619, 88, 1, 24, "Print"],
Cell[86882, 2622, 287, 7, 24, "Print"],
Cell[87172, 2631, 265, 6, 24, "Print"],
Cell[87440, 2639, 89, 1, 24, "Print"],
Cell[87532, 2642, 290, 7, 24, "Print"],
Cell[87825, 2651, 265, 6, 24, "Print"],
Cell[88093, 2659, 88, 1, 24, "Print"],
Cell[88184, 2662, 290, 7, 24, "Print"],
Cell[88477, 2671, 265, 6, 24, "Print"],
Cell[88745, 2679, 89, 1, 24, "Print"],
Cell[88837, 2682, 290, 7, 24, "Print"],
Cell[89130, 2691, 265, 6, 24, "Print"],
Cell[89398, 2699, 89, 1, 24, "Print"],
Cell[89490, 2702, 287, 7, 24, "Print"],
Cell[89780, 2711, 264, 6, 24, "Print"],
Cell[90047, 2719, 89, 1, 24, "Print"],
Cell[90139, 2722, 290, 7, 24, "Print"],
Cell[90432, 2731, 265, 6, 24, "Print"],
Cell[90700, 2739, 89, 1, 24, "Print"],
Cell[90792, 2742, 287, 7, 24, "Print"],
Cell[91082, 2751, 265, 6, 24, "Print"],
Cell[91350, 2759, 88, 1, 24, "Print"],
Cell[91441, 2762, 290, 7, 24, "Print"],
Cell[91734, 2771, 265, 6, 24, "Print"],
Cell[92002, 2779, 89, 1, 24, "Print"],
Cell[92094, 2782, 290, 7, 24, "Print"],
Cell[92387, 2791, 265, 6, 24, "Print"],
Cell[92655, 2799, 89, 1, 24, "Print"],
Cell[92747, 2802, 290, 7, 24, "Print"],
Cell[93040, 2811, 265, 6, 24, "Print"],
Cell[93308, 2819, 87, 1, 24, "Print"],
Cell[93398, 2822, 290, 7, 24, "Print"],
Cell[93691, 2831, 265, 6, 24, "Print"],
Cell[93959, 2839, 89, 1, 24, "Print"],
Cell[94051, 2842, 290, 7, 24, "Print"],
Cell[94344, 2851, 265, 6, 24, "Print"],
Cell[94612, 2859, 89, 1, 24, "Print"],
Cell[94704, 2862, 290, 7, 24, "Print"],
Cell[94997, 2871, 264, 6, 24, "Print"],
Cell[95264, 2879, 88, 1, 24, "Print"],
Cell[95355, 2882, 287, 7, 24, "Print"],
Cell[95645, 2891, 265, 6, 24, "Print"],
Cell[95913, 2899, 89, 1, 24, "Print"],
Cell[96005, 2902, 290, 7, 24, "Print"],
Cell[96298, 2911, 265, 6, 24, "Print"],
Cell[96566, 2919, 88, 1, 24, "Print"],
Cell[96657, 2922, 290, 7, 24, "Print"],
Cell[96950, 2931, 265, 6, 24, "Print"],
Cell[97218, 2939, 89, 1, 24, "Print"],
Cell[97310, 2942, 290, 7, 24, "Print"],
Cell[97603, 2951, 265, 6, 24, "Print"],
Cell[97871, 2959, 89, 1, 24, "Print"],
Cell[97963, 2962, 290, 7, 24, "Print"],
Cell[98256, 2971, 265, 6, 24, "Print"],
Cell[98524, 2979, 89, 1, 24, "Print"],
Cell[98616, 2982, 290, 7, 24, "Print"],
Cell[98909, 2991, 265, 6, 24, "Print"],
Cell[99177, 2999, 89, 1, 24, "Print"],
Cell[99269, 3002, 289, 7, 24, "Print"],
Cell[99561, 3011, 264, 6, 24, "Print"],
Cell[99828, 3019, 89, 1, 24, "Print"],
Cell[99920, 3022, 290, 7, 24, "Print"],
Cell[100213, 3031, 264, 6, 24, "Print"],
Cell[100480, 3039, 88, 1, 24, "Print"],
Cell[100571, 3042, 289, 7, 24, "Print"],
Cell[100863, 3051, 265, 6, 24, "Print"],
Cell[101131, 3059, 89, 1, 24, "Print"],
Cell[101223, 3062, 289, 7, 24, "Print"],
Cell[101515, 3071, 265, 6, 24, "Print"],
Cell[101783, 3079, 89, 1, 24, "Print"],
Cell[101875, 3082, 289, 7, 24, "Print"],
Cell[102167, 3091, 265, 6, 24, "Print"],
Cell[102435, 3099, 89, 1, 24, "Print"],
Cell[102527, 3102, 287, 7, 24, "Print"],
Cell[102817, 3111, 265, 6, 24, "Print"],
Cell[103085, 3119, 88, 1, 24, "Print"],
Cell[103176, 3122, 289, 7, 24, "Print"],
Cell[103468, 3131, 265, 6, 24, "Print"],
Cell[103736, 3139, 89, 1, 24, "Print"],
Cell[103828, 3142, 289, 7, 24, "Print"],
Cell[104120, 3151, 265, 6, 24, "Print"],
Cell[104388, 3159, 89, 1, 24, "Print"],
Cell[104480, 3162, 290, 7, 24, "Print"],
Cell[104773, 3171, 265, 6, 24, "Print"],
Cell[105041, 3179, 87, 1, 24, "Print"],
Cell[105131, 3182, 287, 7, 24, "Print"],
Cell[105421, 3191, 265, 6, 24, "Print"],
Cell[105689, 3199, 89, 1, 24, "Print"],
Cell[105781, 3202, 289, 7, 24, "Print"],
Cell[106073, 3211, 265, 6, 24, "Print"],
Cell[106341, 3219, 88, 1, 24, "Print"],
Cell[106432, 3222, 287, 7, 24, "Print"],
Cell[106722, 3231, 265, 6, 24, "Print"],
Cell[106990, 3239, 88, 1, 24, "Print"],
Cell[107081, 3242, 290, 7, 24, "Print"],
Cell[107374, 3251, 265, 6, 24, "Print"],
Cell[107642, 3259, 89, 1, 24, "Print"],
Cell[107734, 3262, 290, 7, 24, "Print"],
Cell[108027, 3271, 265, 6, 24, "Print"],
Cell[108295, 3279, 89, 1, 24, "Print"],
Cell[108387, 3282, 287, 7, 24, "Print"],
Cell[108677, 3291, 265, 6, 24, "Print"],
Cell[108945, 3299, 89, 1, 24, "Print"],
Cell[109037, 3302, 287, 7, 24, "Print"],
Cell[109327, 3311, 265, 6, 24, "Print"],
Cell[109595, 3319, 89, 1, 24, "Print"],
Cell[109687, 3322, 289, 7, 24, "Print"],
Cell[109979, 3331, 265, 6, 24, "Print"],
Cell[110247, 3339, 89, 1, 24, "Print"],
Cell[110339, 3342, 289, 7, 24, "Print"],
Cell[110631, 3351, 265, 6, 24, "Print"],
Cell[110899, 3359, 89, 1, 24, "Print"],
Cell[110991, 3362, 289, 7, 24, "Print"],
Cell[111283, 3371, 264, 6, 24, "Print"],
Cell[111550, 3379, 89, 1, 24, "Print"],
Cell[111642, 3382, 289, 7, 24, "Print"],
Cell[111934, 3391, 265, 6, 24, "Print"],
Cell[112202, 3399, 89, 1, 24, "Print"],
Cell[112294, 3402, 289, 7, 24, "Print"],
Cell[112586, 3411, 265, 6, 24, "Print"],
Cell[112854, 3419, 89, 1, 24, "Print"],
Cell[112946, 3422, 289, 7, 24, "Print"],
Cell[113238, 3431, 264, 6, 24, "Print"],
Cell[113505, 3439, 90, 1, 24, "Print"],
Cell[113598, 3442, 287, 7, 24, "Print"]
}, Open  ]],
Cell[113900, 3452, 77, 1, 31, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
